Index: utils/tools/DOMAINcfg/src/dombat.F90
===================================================================
--- utils/tools/DOMAINcfg/src/dombat.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/dombat.F90	(revision 14623)
@@ -49,5 +49,5 @@
       latname=TRIM(cn_lat)
    
-      CALL iom_open( bathyfile, inum, lagrif=.FALSE. )
+      CALL iom_open( bathyfile, inum, ldiof=.TRUE. )
       
       ! check if lon/lat are 2D arrays
@@ -404,34 +404,34 @@
         !            
       ENDIF
-      CALL lbc_lnk( 'dom_bat', bathy, 'T', 1. )
+      CALL lbc_lnk( 'dom_bat', bathy, 'T', 1.,kfillmode = jpfillcopy)
 
        ! Correct South and North
-#if defined key_agrif
-      IF( lk_south ) THEN  
-         IF( (nbondj == -1).OR.(nbondj == 2) ) THEN
-           bathy(:,1)=bathy(:,2)
-         ENDIF
-      ELSE
-            bathy(:,1) = 0.
-      ENDIF
-#else
-      IF ((nbondj == -1).OR.(nbondj == 2)) THEN
-            bathy(:,1)=bathy(:,2)
-      ENDIF
-#endif
-
-      IF ((nbondj == 1).OR.(nbondj == 2)) THEN
-         bathy(:,jpj)=bathy(:,jpj-1)
-      ENDIF
-
-      ! Correct West and East
-      IF (jperio /=1) THEN
-         IF ((nbondi == -1).OR.(nbondi == 2)) THEN
-            bathy(1,:)=bathy(2,:)
-         ENDIF
-         IF ((nbondi == 1).OR.(nbondi == 2)) THEN
-         bathy(jpi,:)=bathy(jpi-1,:)
-         ENDIF
-      ENDIF
+! #if defined key_agrif
+!       IF( lk_south ) THEN  
+!          IF( (nbondj == -1).OR.(nbondj == 2) ) THEN
+!            bathy(:,1)=bathy(:,2)
+!          ENDIF
+!       ELSE
+!             bathy(:,1) = 0.
+!       ENDIF
+! #else
+!       IF ((nbondj == -1).OR.(nbondj == 2)) THEN
+!             bathy(:,1)=bathy(:,2)
+!       ENDIF
+! #endif
+
+!       IF ((nbondj == 1).OR.(nbondj == 2)) THEN
+!          bathy(:,jpj)=bathy(:,jpj-1)
+!       ENDIF
+
+!       ! Correct West and East
+!       IF (jperio /=1) THEN
+!          IF ((nbondi == -1).OR.(nbondi == 2)) THEN
+!             bathy(1,:)=bathy(2,:)
+!          ENDIF
+!          IF ((nbondi == 1).OR.(nbondi == 2)) THEN
+!          bathy(jpi,:)=bathy(jpi-1,:)
+!          ENDIF
+!       ENDIF
 
 
Index: utils/tools/DOMAINcfg/src/domcfg.f90
===================================================================
--- utils/tools/DOMAINcfg/src/domcfg.f90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domcfg.f90	(revision 14623)
@@ -55,71 +55,6 @@
       IF( jperio <  0 .OR. jperio > 6 )   CALL ctl_stop( 'jperio is out of range' )
       !
-      CALL dom_glo                   ! global domain versus zoom and/or local domain
-      !
    END SUBROUTINE dom_cfg
 
-   SUBROUTINE dom_glo
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE dom_glo  ***
-      !!
-      !! ** Purpose :   initialization of global domain <--> local domain indices
-      !!
-      !! ** Method  :   
-      !!
-      !! ** Action  : - mig , mjg : local  domain indices ==> global domain indices
-      !!              - mi0 , mi1 : global domain indices ==> local  domain indices
-      !!              - mj0,, mj1   (global point not in the local domain ==> mi0>mi1 and/or mj0>mj1)
-      !!----------------------------------------------------------------------
-      INTEGER ::   ji, jj   ! dummy loop argument
-      !!----------------------------------------------------------------------
-      !
-      DO ji = 1, jpi                 ! local domain indices ==> global domain indices
-        mig(ji) = ji + nimpp - 1
-      END DO
-      DO jj = 1, jpj
-        mjg(jj) = jj + njmpp - 1
-      END DO
-      !                              ! global domain indices ==> local domain indices
-      !                                   ! (return (m.0,m.1)=(1,0) if data domain gridpoint is to the west/south of the 
-      !                                   ! local domain, or (m.0,m.1)=(jp.+1,jp.) to the east/north of local domain. 
-      DO ji = 1, jpiglo
-        mi0(ji) = MAX( 1 , MIN( ji - nimpp + 1, jpi+1 ) )
-        mi1(ji) = MAX( 0 , MIN( ji - nimpp + 1, jpi   ) )
-      END DO
-      DO jj = 1, jpjglo
-        mj0(jj) = MAX( 1 , MIN( jj - njmpp + 1, jpj+1 ) )
-        mj1(jj) = MAX( 0 , MIN( jj - njmpp + 1, jpj   ) )
-      END DO
-      IF(lwp) THEN                   ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) 'dom_glo : domain: global <<==>> local '
-         WRITE(numout,*) '~~~~~~~ '
-         WRITE(numout,*) '   global domain:   jpiglo = ', jpiglo, ' jpjglo = ', jpjglo, ' jpkglo = ', jpkglo
-         WRITE(numout,*) '   local  domain:   jpi    = ', jpi   , ' jpj    = ', jpj   , ' jpk    = ', jpk
-         WRITE(numout,*)
-         WRITE(numout,*) '   conversion from local to global domain indices (and vise versa) done'
-
-!            WRITE(numout,*)
-!            WRITE(numout,*) '          conversion local  ==> global i-index domain (mig)'
-!            WRITE(numout,25)              (mig(ji),ji = 1,jpi)
-!            WRITE(numout,*)
-!            WRITE(numout,*) '          conversion global ==> local  i-index domain'
-!            WRITE(numout,*) '             starting index (mi0)'
-!            WRITE(numout,25)              (mi0(ji),ji = 1,jpiglo)
-!            WRITE(numout,*) '             ending index (mi1)'
-!            WRITE(numout,25)              (mi1(ji),ji = 1,jpiglo)
-!            WRITE(numout,*)
-!            WRITE(numout,*) '          conversion local  ==> global j-index domain (mjg)'
-!            WRITE(numout,25)              (mjg(jj),jj = 1,jpj)
-!            WRITE(numout,*)
-!            WRITE(numout,*) '          conversion global ==> local  j-index domain'
-!            WRITE(numout,*) '             starting index (mj0)'
-!            WRITE(numout,25)              (mj0(jj),jj = 1,jpjglo)
-!            WRITE(numout,*) '             ending index (mj1)'
-!            WRITE(numout,25)              (mj1(jj),jj = 1,jpjglo)
-      ENDIF
- 25   FORMAT( 100(10x,19i4,/) )
-      !
-   END SUBROUTINE dom_glo
    !!======================================================================
 END MODULE domcfg
Index: utils/tools/DOMAINcfg/src/domclo.F90
===================================================================
--- utils/tools/DOMAINcfg/src/domclo.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domclo.F90	(revision 14623)
@@ -93,10 +93,10 @@
       !!---------------------------------------------------------------------
       
-      REWIND( numnam_ref )              ! Namelist namlbc in reference namelist : Lateral momentum boundary condition
+   !   REWIND( numnam_ref )              ! Namelist namlbc in reference namelist : Lateral momentum boundary condition
       READ  ( numnam_ref, namclo, IOSTAT = ios, ERR = 901 )
-901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namclo in reference namelist', lwp )
-      REWIND( numnam_cfg )              ! Namelist namlbc in configuration namelist : Lateral momentum boundary condition
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namclo in reference namelist')
+   !   REWIND( numnam_cfg )              ! Namelist namlbc in configuration namelist : Lateral momentum boundary condition
       READ  ( numnam_cfg, namclo, IOSTAT = ios, ERR = 902 )
-902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namclo in configuration namelist', lwp )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namclo in configuration namelist')
       IF(lwm) WRITE ( numond, namclo )
 
Index: utils/tools/DOMAINcfg/src/domhgr.F90
===================================================================
--- utils/tools/DOMAINcfg/src/domhgr.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domhgr.F90	(revision 14623)
@@ -392,10 +392,10 @@
          IF(lwp) THEN
             WRITE(numout,*) 
-            WRITE(numout,*) '          Beta-plane: Beta parameter = constant = ', ff_f(nldi,nldj)
-            WRITE(numout,*) '          Coriolis parameter varies from ', ff_f(nldi,nldj),' to ', ff_f(nldi,nlej)
+            WRITE(numout,*) '          Beta-plane: Beta parameter = constant = ', ff_f(Nis0,Njs0)
+            WRITE(numout,*) '          Coriolis parameter varies from ', ff_f(Nis0,Njs0),' to ', ff_f(Nis0,Nje0)
          ENDIF
          IF( lk_mpp ) THEN 
-            zminff=ff_f(nldi,nldj)
-            zmaxff=ff_f(nldi,nlej)
+            zminff=ff_f(Nis0,Njs0)
+            zmaxff=ff_f(Nis0,Nje0)
             CALL mpp_min( 'toto',zminff )   ! min over the global domain
             CALL mpp_max( 'toto',zmaxff )   ! max over the global domain
@@ -415,10 +415,10 @@
             WRITE(numout,*) 
             WRITE(numout,*) '          Beta-plane and rotated domain : '
-            WRITE(numout,*) '          Coriolis parameter varies in this processor from ', ff_f(nldi,nldj),' to ', ff_f(nldi,nlej)
+            WRITE(numout,*) '          Coriolis parameter varies in this processor from ', ff_f(Nis0,Njs0),' to ', ff_f(Nis0,Nje0)
          ENDIF
          !
          IF( lk_mpp ) THEN 
-            zminff=ff_f(nldi,nldj)
-            zmaxff=ff_f(nldi,nlej)
+            zminff=ff_f(Nis0,Njs0)
+            zmaxff=ff_f(Nis0,Nje0)
             CALL mpp_min('toto', zminff )   ! min over the global domain
             CALL mpp_max( 'toto',zmaxff )   ! max over the global domain
@@ -462,4 +462,5 @@
       ENDIF
       !
+
       IF (ln_read_cfg) THEN
          coordinate_filename=TRIM(cn_domcfg)
@@ -469,28 +470,28 @@
       CALL iom_open( coordinate_filename, inum )
       !
-      CALL iom_get( inum, jpdom_data, 'glamt', glamt, lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'glamu', glamu, lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'glamv', glamv, lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'glamf', glamf, lrowattr=ln_use_jattr )
-      !
-      CALL iom_get( inum, jpdom_data, 'gphit', gphit, lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'gphiu', gphiu, lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'gphiv', gphiv, lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'gphif', gphif, lrowattr=ln_use_jattr )
-      !
-      CALL iom_get( inum, jpdom_data, 'e1t'  , e1t  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e1u'  , e1u  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e1v'  , e1v  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e1f'  , e1f  , lrowattr=ln_use_jattr )
-      !
-      CALL iom_get( inum, jpdom_data, 'e2t'  , e2t  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e2u'  , e2u  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e2v'  , e2v  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e2f'  , e2f  , lrowattr=ln_use_jattr )
+      CALL iom_get( inum, jpdom_global, 'glamt', glamt, cd_type = 'T', psgn = 1._wp )
+      CALL iom_get( inum, jpdom_global, 'glamu', glamu, cd_type = 'U', psgn = 1._wp )
+      CALL iom_get( inum, jpdom_global, 'glamv', glamv, cd_type = 'V', psgn = 1._wp )
+      CALL iom_get( inum, jpdom_global, 'glamf', glamf, cd_type = 'F', psgn = 1._wp )
+      !
+      CALL iom_get( inum, jpdom_global, 'gphit', gphit, cd_type = 'T', psgn = 1._wp )
+      CALL iom_get( inum, jpdom_global, 'gphiu', gphiu, cd_type = 'U', psgn = 1._wp )
+      CALL iom_get( inum, jpdom_global, 'gphiv', gphiv, cd_type = 'V', psgn = 1._wp )
+      CALL iom_get( inum, jpdom_global, 'gphif', gphif, cd_type = 'F', psgn = 1._wp )
+      !
+      CALL iom_get( inum, jpdom_global, 'e1t'  , e1t , cd_type = 'T', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e1u'  , e1u , cd_type = 'U', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e1v'  , e1v , cd_type = 'V', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e1f'  , e1f , cd_type = 'F', psgn = 1._wp, kfill = jpfillcopy )
+      !
+      CALL iom_get( inum, jpdom_global, 'e2t'  , e2t , cd_type = 'T', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e2u'  , e2u , cd_type = 'U', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e2v'  , e2v , cd_type = 'V', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e2f'  , e2f , cd_type = 'F', psgn = 1._wp, kfill = jpfillcopy )
       !
       IF( iom_varid( inum, 'e1e2u', ldstop = .FALSE. ) > 0 ) THEN
          IF(lwp) WRITE(numout,*) 'hgr_read : e1e2u & e1e2v read in coordinates file'
-         CALL iom_get( inum, jpdom_data, 'e1e2u'  , e1e2u  , lrowattr=ln_use_jattr )
-         CALL iom_get( inum, jpdom_data, 'e1e2v'  , e1e2v  , lrowattr=ln_use_jattr )
+         CALL iom_get( inum, jpdom_global, 'e1e2u', e1e2u, cd_type = 'U', psgn = 1._wp, kfill = jpfillcopy )
+         CALL iom_get( inum, jpdom_global, 'e1e2v', e1e2v, cd_type = 'V', psgn = 1._wp, kfill = jpfillcopy )
          ke1e2u_v = 1
       ELSE
Index: utils/tools/DOMAINcfg/src/domisf.F90
===================================================================
--- utils/tools/DOMAINcfg/src/domisf.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domisf.F90	(revision 14623)
@@ -59,11 +59,11 @@
       !
       ! 0.0 read namelist
-      REWIND( numnam_ref )              ! Namelist namzgr_isf in reference namelist : ice shelf geometry definition
+ !     REWIND( numnam_ref )              ! Namelist namzgr_isf in reference namelist : ice shelf geometry definition
       READ  ( numnam_ref, namzgr_isf, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_isf in reference namelist', lwp )
-
-      REWIND( numnam_cfg )              ! Namelist namzgr_sco in configuration namelist : ice shelf geometry definition
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_isf in reference namelist')
+
+ !     REWIND( numnam_cfg )              ! Namelist namzgr_sco in configuration namelist : ice shelf geometry definition
       READ  ( numnam_cfg, namzgr_isf, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_isf in configuration namelist', lwp )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_isf in configuration namelist')
       IF(lwm) WRITE ( numond, namzgr_isf )
       !
@@ -295,5 +295,5 @@
          zrisfdep = risfdep
          WHERE ( mbathy(:,:) == 0 )
-            imask(:,:) = jpk
+            imask(:,:) = 0
             imbathy(:,:) = jpk
          END WHERE
@@ -302,5 +302,5 @@
                IF(  (misfdep(ji,jj) > 1) .AND. (mbathy(ji,jj) > 0) ) THEN
                   !
-                  ! what it should be (1 = should be connected; >= jpk = should not be connected)
+                  ! what it should be
                   imskip1 = imask(ji,jj) * imask(ji+1,jj  )  ! 1 = should be connected
                   imskim1 = imask(ji,jj) * imask(ji-1,jj  )  ! 1 = should be connected
@@ -308,5 +308,5 @@
                   imskjm1 = imask(ji,jj) * imask(ji  ,jj-1)  ! 1 = should be connected
                   !
-                  ! what it is ? ( 1 = no effective connection; jpk = effective connection )
+                  ! what it is
                   imskip1_r=jpk ; imskim1_r=jpk; imskjp1_r=jpk; imskjm1_r=jpk
                   IF (misfdep(ji,jj) > imbathy(ji+1,jj  )) imskip1_r=1.0 ! 1 = no effective connection
@@ -316,11 +316,10 @@
                   !
                   ! defining level needed for connectivity
-                  ! imskip1 * imskip1_r == 1   means    connection need to be enforce
-                  ! imskip1 * imskip1_r >= jpk means no connection need to be enforce
+                  ! imskip1 * imskip1_r == 1 means connections need to be enforce
                   jk=MIN(imbathy(ji+1,jj  ) * imskip1_r * imskip1, &
                      &   imbathy(ji-1,jj  ) * imskim1_r * imskim1, &
                      &   imbathy(ji  ,jj+1) * imskjp1_r * imskjp1, &
                      &   imbathy(ji  ,jj-1) * imskjm1_r * imskjm1, &
-                     &   jpk ) ! add jpk in the MIN to avoid out of boundary later on
+                     &   jpk+1 ) ! add jpk in the MIN to avoid out of boundary later on
                   !
                   ! if connectivity is OK or no connection needed (grounding line) or grounded, zmisfdep=misfdep
Index: utils/tools/DOMAINcfg/src/dommsk.F90
===================================================================
--- utils/tools/DOMAINcfg/src/dommsk.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/dommsk.F90	(revision 14623)
@@ -98,10 +98,10 @@
       !!---------------------------------------------------------------------
       !
-      REWIND( numnam_ref )              ! Namelist namlbc in reference namelist : Lateral momentum boundary condition
+    !  REWIND( numnam_ref )              ! Namelist namlbc in reference namelist : Lateral momentum boundary condition
       READ  ( numnam_ref, namlbc, IOSTAT = ios, ERR = 901 )
-901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlbc in reference namelist', lwp )
-      REWIND( numnam_cfg )              ! Namelist namlbc in configuration namelist : Lateral momentum boundary condition
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlbc in reference namelist')
+    !  REWIND( numnam_cfg )              ! Namelist namlbc in configuration namelist : Lateral momentum boundary condition
       READ  ( numnam_cfg, namlbc, IOSTAT = ios, ERR = 902 )
-902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlbc in configuration namelist', lwp )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlbc in configuration namelist')
       IF(lwm) WRITE ( numond, namlbc )
       
@@ -156,5 +156,5 @@
             END DO  
          END DO  
-      ELSE
+         ELSE
          DO jk = 1, jpk
             DO jj = 1, jpj
@@ -209,6 +209,6 @@
       ! --------------------
       !
-      iif = nn_hls   ;   iil = nlci - nn_hls + 1
-      ijf = nn_hls   ;   ijl = nlcj - nn_hls + 1
+      iif = nn_hls   ;   iil = jpi - nn_hls + 1
+      ijf = nn_hls   ;   ijl = jpj - nn_hls + 1
       !
       !                          ! halo mask : 0 on the halo and 1 elsewhere
@@ -225,7 +225,7 @@
          tpol(jpiglo/2+1:jpiglo) = 0._wp
          fpol(     1    :jpiglo) = 0._wp
-         IF( mjg(nlej) == jpjglo ) THEN                  ! only half of the nlcj-1 row for tmask_h
+         IF( mjg(Nje0) == jpjglo ) THEN                  ! only half of the nlcj-1 row for tmask_h
             DO ji = iif+1, iil-1
-               tmask_h(ji,nlej-1) = tmask_h(ji,nlej-1) * tpol(mig(ji))
+               tmask_h(ji,Nje0-1) = tmask_h(ji,Nje0-1) * tpol(mig(ji))
             END DO
          ENDIF
@@ -275,7 +275,7 @@
 #if defined key_agrif 
             IF( .NOT. AGRIF_Root() ) THEN 
-               IF(lk_east)  fmask(nlci-1 , :     ,jk) = 0.e0      ! east 
+               IF(lk_east)  fmask(jpi-1 , :     ,jk) = 0.e0      ! east 
                IF(lk_west)  fmask(1      , :     ,jk) = 0.e0      ! west 
-               IF(lk_north) fmask(:      ,nlcj-1 ,jk) = 0.e0      ! north 
+               IF(lk_north) fmask(:      ,jpj-1 ,jk) = 0.e0      ! north 
                IF(lk_south) fmask(:      ,1      ,jk) = 0.e0      ! south 
             ENDIF 
@@ -294,7 +294,5 @@
       ! -------------------------------- 
       !
-      ! write mesh mask
-      IF ( nn_msh > 0 ) CALL dom_wri
-      !
+
       CALL usr_def_fmask( cp_cfg, jp_cfg, fmask )
       !
Index: utils/tools/DOMAINcfg/src/domngb.F90
===================================================================
--- utils/tools/DOMAINcfg/src/domngb.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domngb.F90	(revision 14623)
@@ -46,4 +46,5 @@
       INTEGER :: ik         ! working level
       INTEGER , DIMENSION(2) ::   iloc
+      REAL(wp)               ::   zlon, zmini
       REAL(wp), DIMENSION(jpi,jpj) ::   zglam, zgphi, zmask, zdist
       !!--------------------------------------------------------------------
@@ -53,11 +54,15 @@
       IF ( PRESENT(kkk) ) ik=kkk
       SELECT CASE( cdgrid )
-      CASE( 'U' )  ; zglam(:,:) = glamu(:,:) ; zgphi(:,:) = gphiu(:,:) ; zmask(nldi:nlei,nldj:nlej) = umask(nldi:nlei,nldj:nlej,ik)
-      CASE( 'V' )  ; zglam(:,:) = glamv(:,:) ; zgphi(:,:) = gphiv(:,:) ; zmask(nldi:nlei,nldj:nlej) = vmask(nldi:nlei,nldj:nlej,ik)
-      CASE( 'F' )  ; zglam(:,:) = glamf(:,:) ; zgphi(:,:) = gphif(:,:) ; zmask(nldi:nlei,nldj:nlej) = fmask(nldi:nlei,nldj:nlej,ik)
-      CASE DEFAULT ; zglam(:,:) = glamt(:,:) ; zgphi(:,:) = gphit(:,:) ; zmask(nldi:nlei,nldj:nlej) = tmask(nldi:nlei,nldj:nlej,ik)
+      CASE( 'U' )  ; zglam(:,:) = glamu(:,:) ; zgphi(:,:) = gphiu(:,:) ; zmask(Nis0:Nie0,Njs0:Nje0) = umask(Nis0:Nie0,Njs0:Nje0,ik)
+      CASE( 'V' )  ; zglam(:,:) = glamv(:,:) ; zgphi(:,:) = gphiv(:,:) ; zmask(Nis0:Nie0,Njs0:Nje0) = vmask(Nis0:Nie0,Njs0:Nje0,ik)
+      CASE( 'F' )  ; zglam(:,:) = glamf(:,:) ; zgphi(:,:) = gphif(:,:) ; zmask(Nis0:Nie0,Njs0:Nje0) = fmask(Nis0:Nie0,Njs0:Nje0,ik)
+      CASE DEFAULT ; zglam(:,:) = glamt(:,:) ; zgphi(:,:) = gphit(:,:) ; zmask(Nis0:Nie0,Njs0:Nje0) = tmask(Nis0:Nie0,Njs0:Nje0,ik)
       END SELECT
 
-      zdist = dist(plon, plat, zglam, zgphi)
+      zlon       = MOD( plon       + 720., 360. )                                     ! plon between    0 and 360
+      zglam(:,:) = MOD( zglam(:,:) + 720., 360. )                                     ! glam between    0 and 360
+      IF( zlon > 270. )   zlon = zlon - 360.                                          ! zlon between  -90 and 270
+      IF( zlon <  90. )   WHERE( zglam(:,:) > 180. ) zglam(:,:) = zglam(:,:) - 360.   ! glam between -180 and 180
+      zglam(:,:) = zglam(:,:) - zlon
 
       IF( lk_mpp ) THEN  
Index: utils/tools/DOMAINcfg/src/domwri.F90
===================================================================
--- utils/tools/DOMAINcfg/src/domwri.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domwri.F90	(revision 14623)
@@ -215,5 +215,7 @@
       lldbl(:,:,1) = puniq(:,:) == ztstref(:,:)   ! check which values have been changed 
       !
-      puniq(:,:) = REAL( COUNT( lldbl(:,:,:), dim = 3 ) , wp )
+      puniq(:,:) = 1.                             ! default definition
+      ! fill only the inner part of the cpu with llbl converted into real 
+      puniq(Nis0:Nie0,Njs0:Nje0) = REAL( COUNT( lldbl(Nis0:Nie0,Njs0:Nje0,:), dim = 3 ) , wp )
       !
    END SUBROUTINE dom_uniq
